#ifndef MAINWINDOW_H
#define MAINWINDOW_H

//-----------------------------------------------------------------------------
// local includes
#include "Base.h"

//-----------------------------------------------------------------------------
class CScene;

//-----------------------------------------------------------------------------
/// Mainwindow
/**
* 
*/
class MainWindow : public QMainWindow
{
  /** render image */
  QImage image;

  /** the scene */
  CScene* scene;

  // time variable
  double tau;

  /** camera z pos */
  double zPos;

  /** pause flag */
  bool pause;

//-----------------------------------------------------------------------------
public:
 
  /** Ctor.  */
  MainWindow( QWidget* parent = 0, Qt::WindowFlags flags = 0 );

  /** Dtor. */
  ~MainWindow();

//-----------------------------------------------------------------------------
protected:

  void timerEvent( QTimerEvent* );

  //void keyReleaseEvent( QKeyEvent* );
	void keyPressEvent( QKeyEvent* e );

  void paintEvent( QPaintEvent* );

  void resizeEvent( QResizeEvent* );

  /** Scene rendering. */
  void render();

  /** Save the image. */
  void save();

//-----------------------------------------------------------------------------
private:

  /** Initialize the scene. */
  void initScene();

};

#endif
